#if !defined(_INC_WINDOWS) && !defined(__WINDOWS_H)
    #include <windows.h>
#endif

/* WDJ_Pbh == PlayBackHook */

#define WDJ_PBH_CTL     0x0100
#define WDJ_PBH_ALT     0x0200
#define WDJ_PBH_CTLALT  0x0300

typedef void *WDJ_Pbh;

WDJ_Pbh     WDJ_Pbh_Create(HINSTANCE Instance);

int         WDJ_Pbh_AppendRaw(WDJ_Pbh Handle, UINT Message, UINT Low,
                       UINT High, DWORD Delay);
int         WDJ_Pbh_AppendChar(WDJ_Pbh Handle, int Char);
int         WDJ_Pbh_AppendString(WDJ_Pbh Handle, const char *String);

int         WDJ_Pbh_Play(WDJ_Pbh Handle);
int         WDJ_Pbh_Pump(WDJ_Pbh Handle);

int         WDJ_Pbh_PlayCallback(WDJ_Pbh Handle, WNDPROC Callback,
                     HWND W, UINT M, WPARAM p1, LPARAM p2);
int         WDJ_Pbh_PumpCallback(WDJ_Pbh Handle, WNDPROC Callback,
                     HWND W, UINT M, WPARAM p1, LPARAM p2);

int         WDJ_Pbh_Destroy(WDJ_Pbh Handle);

int         WDJ_Pbh_String(HINSTANCE Instance, const char *String);

